// A simple MTS server object for managing  distributed transactions
// This transaction deletes a record from a table and
// adds its data and a string typed by a user to
// two other tables by means of creating two additional
// server objects
//
// By N.Elmanova


unit pay1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComServ, ComObj, VCLCom, StdVcl, BdeProv, BdeMts, DataBkr, DBClient,
  MtsRdm, Mtx, paysrv_TLB, dels_TLB, st_TLB, DBTables, Provider, Db;

type
  Tpays = class(TMtsDataModule, Ipays)
    paytable: TTable;
    PayProvider: TProvider;
    Database3: TDatabase;
    Session3: TSession;
 private
 FStockDM1: IStockDM1;
 FDelDM: IDelDM;
    { Private declarations }
  public
    { Public declarations }
  protected
    function GetPays: OleVariant; safecall;
    procedure AddPay(Pnum: Integer; Pval: Double; const Address: WideString);
      safecall;
    procedure DelPay(Pnum: Integer); safecall;
    procedure DoTrans(Num: Integer; Val: Double; const Addr,
      Gname: WideString); safecall;
  end;

var
  pays: Tpays;

implementation

{$R *.DFM}

function Tpays.GetPays: OleVariant;
begin
     Result:=PayProvider.Data;
     SetComplete;
end;

procedure Tpays.AddPay(Pnum: Integer; Pval: Double;
  const Address: WideString);
begin
try
    database3.open;
    paytable.open;
    paytable.append;
    paytable.fieldbyname('OrdNum').Value:=PNum;
    paytable.fieldbyname('Payment').Value:=Pval;
    paytable.fieldbyname('Address').Value:=Address;
    paytable.post;
    paytable.close;
    database3.close;
    SetComplete;
except
    SetAbort;
    raise;
end;
end;

procedure Tpays.DelPay(Pnum: Integer);
begin
try
  Database3.Open;
  paytable.Open;
  paytable.SetRangeStart;
  paytable.FieldByName('ordnum').AsInteger:=Pnum;
  paytable.SetRangeEnd;
  paytable.FieldByName('ordnum').AsInteger:=Pnum;
  paytable.ApplyRange;
  paytable.Delete;
  paytable.Close;
  Database3.Close;
  SetComplete;
except
  SetAbort;
raise;
end;
end;

procedure Tpays.DoTrans(Num: Integer; Val: Double; const Addr,
  Gname: WideString);
 begin
try
  OleCheck(ObjectContext.CreateInstance(CLASS_StockDM1, IStockDM1, FStockDM1));
  OleCheck(ObjectContext.CreateInstance(CLASS_DelDM, IDelDM, FDelDM));
  FStockDM1.DeleteGoods(Num);
  FDelDM.AddDelivery(Num,Gname,Addr);
  AddPay(Num,Val,Addr);
except
  DisableCommit;
raise;
end;
  EnableCommit;
end;

initialization
  TComponentFactory.Create(ComServer, Tpays,
    Class_pays, ciMultiInstance, tmApartment);
end.